#include "common/theLogger.h"

static const char *TAG = "System";

void print_logo()
{
       const char *Logo[] = {
           "\n  ______  _____ _____ ____ ___        ______ _                        _ _ \n",
           " |  ____|/ ____|  __ \\___ \\__ \\      |  ____(_)                      | | |\n",
           " | |__  | (___ | |__) |__) | ) |_____| |__   _ _ __ _____      ____ _| | |\n",
           " |  __|  \\___ \\|  ___/|__ < / /______|  __| | | '__/ _ \\ \\ /\\ / / _` | | |\n",
           " | |____ ____) | |    ___) / /_      | |    | | | |  __/\\ V  V / (_| | | |\n",
           " |______|_____/|_|   |____/____|     |_|    |_|_|  \\___| \\_/\\_/ \\__,_|_|_|\n\n",
       };
       int logoSize = sizeof Logo / sizeof *Logo;
       for (int i = 0; i < logoSize; ++i)
       {
              printf(Logo[i]);
       }
}

void print_esp32_information()
{
       esp_chip_info_t chip_info;
       esp_chip_info(&chip_info);

       ESP_LOGI(TAG, "This is an ESP32 chip with %d CPU cores, WiFi%s%s, silicon revision %d",
                chip_info.cores,
                (chip_info.features & CHIP_FEATURE_BT) ? "/BT" : "",
                (chip_info.features & CHIP_FEATURE_BLE) ? "/BLE" : "",
                chip_info.revision);

       ESP_LOGI(TAG, "%dMB %s flash, minimum free heap size: %d bytes\n", spi_flash_get_chip_size() / (1024 * 1024),
                (chip_info.features & CHIP_FEATURE_EMB_FLASH) ? "embedded" : "external",
                esp_get_minimum_free_heap_size());
}

void setup_all_log_levels()
{
       esp_log_level_set("*", ESP_LOG_ERROR);
       esp_log_level_set(TAG, ESP_LOG_INFO);
       esp_log_level_set("NVS", ESP_LOG_INFO);
       esp_log_level_set("WiFi", ESP_LOG_INFO);
       esp_log_level_set("SNTP", ESP_LOG_INFO);
       esp_log_level_set("GPIO", ESP_LOG_INFO);
       esp_log_level_set("WebServer", ESP_LOG_INFO);
       esp_log_level_set("Firewall", ESP_LOG_INFO);
}
